<?php
/**
 * MyBB 1.6
 * Copyright 2010 MyBB Group, All Rights Reserved
 *
 * Website: http://mybb.com
 * License: http://mybb.com/about/license
 *
 * $Id: portal.php 5380 2011-02-21 12:04:43Z Tomm $
 */



define("IN_MYBB", 1);
define("IN_PORTAL", 1);
define('THIS_SCRIPT', 'hyperportal.php');

// set the path to your forums directory here (without trailing slash)
$forumdir = "./";
$change_dir = "./";

if(!@chdir($forumdir) && !empty($forumdir))
{
	if(@is_dir($forumdir))
	{
		$change_dir = $forumdir;
	}
	else
	{
		die("\$forumdir is invalid!");
	}
}


require_once $change_dir."/global.php";
require_once MYBB_ROOT."inc/functions_post.php";
require_once MYBB_ROOT."inc/functions_user.php";
require_once MYBB_ROOT."inc/class_parser.php";


//See if we have to go to the forum
if($mybb->usergroup['gid']!=1 && $mybb->settings['hyperportal_forum'] && !$mybb->user['useportal'])
	header('Location: index.php');

$templatelist ="hyperportal,headerincludes,footer,header";

// Fetch the current URL
$portal_url = get_current_location();

add_breadcrumb("PORTAL", "hyperportal.php");

$lang->load("portal");
$lang->load("hyperportal");		


//Amount of sectors configured
$sectors=$mybb->settings["hyperportal_sectors"];



	$widget=1;
	//If it's a guest i see if he has a cookie
	if($mybb->usergroup['gid']==1)
	{
		//I ony use Cookies for not registered users that can't persist
		$widgetCookieName = $mybb->settings['cookieprefix'] . 'widgets_config';
		$mybb->user['widgets_config']=$_COOKIE[$widgetCookieName];
	}
	
	
	//If he hasn't any special config saved, i use the one from de usergroup
	if(!isset($mybb->user[widgets_config]) || $mybb->user[widgets_config]=="")
	{
		$strconfig=unserialize($mybb->usergroup['hyperportal_template']);
		$widgets_config=array();
		for($i=1;$i<=$sectors;$i++)
		{
			$widgets_config["sector$i"]=array();

			if(is_array($strconfig["sector$i"]))
				foreach($strconfig["sector$i"] as $wcfg)
				{
			
					$widgets_config["sector$i"][$wcfg]['name']=$wcfg;
					$widgets_config["sector$i"][$wcfg]['minimized']=0;
				}
		}
	
		$mybb->user['widgets_config']=serialize($widgets_config);
	
		//First time of a non user
		if($mybb->usergroup['gid']==1)
			setcookie($widgetCookieName,$mybb->user['widgets_config']);
		
	}
	//If it has got a special config, i use it
	else
		$widgets_config=unserialize($mybb->user['widgets_config']);
	
	
	$widgetscache=$cache->read("hyperPortalWidgets",true);

$hypercontent="

 

<div id='hypercontent' >";

for($i=1;$i<=$sectors;$i++)
{

	if($mybb->settings["hyperportal_addclose"])
		$hypercontent.="<div id='sector{$i}Column'><div id='sector{$i}Add' class='sectorAdd'>$lang->h_add_widget</div>";
	else 
		$hypercontent.="<div id='sector{$i}Column'><span id='' style='height:0px;'></span>";
	
	//Aca van los widget de la izquierda
	$files=$widgets_config["sector$i"];
	
	if(count($files)>0)
	foreach($files as $codename=>$codeConfig)
	{

		//Si no es para invitados ni lo cargo
		if($mybb->usergroup['gid']==1 && $widgetscache["sector$i"][$codename]['guests']==0)
			continue;
			
		require_once MYBB_ROOT."inc/widgets/sector$i/".$codename.".php";;
		
		$infofunc = $codename."_info";
		//Si no tiene un info no es un widget
		if(!function_exists($infofunc) || !is_array($widgetscache["sector$i"]) || !isset($widgetscache["sector$i"][$codename]))
				{
					continue;
				}
		$widgetinfo = $infofunc();
		
		$conffunc = $codename."_configuration";
		$configButton=false;
		$widget_settings=array();
		if(function_exists($conffunc))
		{
			if($mybb->usergroup['gid']!=1)
				$configButton=true;
			//If he didn't config before I use the default settings
			if(!isset($codeConfig['configuration']))
			{
				$wsettings=$conffunc();
			
				foreach($wsettings as $name=>$wsetting)
				{
					$widget_settings[$name]=$wsetting['value'];
				}
			}
			//Else I use his config for the widget
			else
				$widget_settings=$codeConfig['configuration'];
		}
		//Reviso que el widget devuelva algo
		$realcontent=$codename();
		if(!strlen($realcontent))
		{
			$hypercontent.="<div style='display:none;' class='widget trow1 smalltext $notClass' position='sector$i' id='widget_$codename' minimized='minimized_{$codeConfig['minimized']}'></div>";
			continue;
		}
		//Reviso si el bloque esta minimizado
		$display="";
		$collapsed="";
		if($codeConfig['minimized']==1)
		{
			$display="display:none;";
			$collapsed="_collapsed";
		}
		
		$notClass="";
		if($widgetscache["sector$i"][$codename]['fixed']==1)
			$notClass = "notSortable";
		$hypercontent.="<div class='widget trow1 smalltext $notClass' position='sector$i' id='widget_$codename' minimized='minimized_{$codeConfig['minimized']}'>";
		if($widgetscache["sector$i"][$codename]['header']==1)
		{
			$hypercontent.= "
				<div class=' thead moveHeader' >
				
					$widgetinfo[name]";
			
			if($mybb->settings["hyperportal_addclose"])
				$hypercontent.="<img src='images/hyperportal/close.gif' class='hyperButton'  onClick='closeWidget(this)'/>";
				$hypercontent.="<img src='images/hyperportal/collapse$collapsed.gif'  class='hyperButton' class='minimize'  onClick='minimize(this)'/>";
			if($configButton)
				$hypercontent.="<img  class='hyperButton' src='images/hyperportal/config.png'onClick='configWidget(this)'/>";
				$hypercontent.="</div>";
	}
	
			$hypercontent.= "
			<div class='widgetContent' style='$display'>
				$realcontent
			</div>";
	
			$hypercontent.="</div>";
		$widget++;
	}
	
	$hypercontent.="</div>";
	}
$hypercontent.="
</div>

<script>
    jQuery(function() {
";
for($i=1;$i<=$sectors;$i++)
	$hypercontent.= "
		jQuery( '#sector{$i}Column' ).sortable({
	         	handle: '.moveHeader',
	   			cursor: 'move',
	   			items: '.widget:not(.notSortable)',
	   			placeholder: 'dragBorder',
	   			forcePlaceholderSize:true,
	   			tolerance: '30%',
	   			update: function( event, ui ) {
	   					 jQuery(this).sortable('option', 'items', '.widget'); 
	   					var order = jQuery(this).sortable('serialize'); 
	   					var minOrder=jQuery(this).sortable('serialize',{attribute: 'minimized'} ); 
	   					jQuery.ajax('xmlhttp.php?action=sortWidgets&pos=sector$i&'+order+'&'+minOrder, {type: 'get'});
	   				    jQuery(this).sortable('option', 'items', '.widget:not(.notSortable)'); 
	   			}
	         });
	    ";

	$hypercontent.= "
    });";
	
if($mybb->settings["hyperportal_addclose"])
$hypercontent.="
    function closeWidget(element)
    {
       jQuery.ajax('xmlhttp.php?action=closeWidget&pos='+jQuery(element).parent().parent().attr('position')+'&widget='+jQuery(element).parent().parent().attr('id'), {type: 'get'});
    	jQuery(element).parent().parent().fadeOut('fast', function() {
    		jQuery(element).parent().parent().remove();
  });
    	}

    	
    function addWidget(pos,widget)
    {
    	jQuery.ajax('xmlhttp.php?action=addWidget&pos='+pos+'&widget='+widget, {type: 'get',
    	
    	complete:
    	function(request) 
	    		{ 
	    		
	    			jQuery('#'+pos+'Column').append(request.responseText);    			
		    	
    	}
    	});
    	
    }
    	";
  $hypercontent.= " 
    
    function configWidget(element)
    {
  			pos=jQuery(element).parent().parent().attr('position');
  			widget=jQuery(element).parent().parent().attr('id');
 					 spinnerImage= 'images/spinner_big.gif';
    				spinner = new ActivityIndicator('body', {image: spinnerImage});
    				jQuery('#sector{$i}Add').hide();
    				jQuery.ajax
    				(
	    				'xmlhttp.php?action=configWidget&pos='+pos+'&widget='+widget,
	    				{
	    					type: 'get',
	    					complete: function(request) 
	    					{ 
	    						spinner.destroy();
								my_dialog=jQuery('<div title=\'".$lang->h_config_widget."\'>'+request.responseText+'</div>').dialog({modal: true});
	    						jQuery('#sector{$i}Add').show();
	    					}
	    				}
	    			);
    }

    
    function minimize(button)
    {
    	var element=jQuery(button).parent().parent();
    	var offElement=element.children('.widgetContent');
 

		element.attr('minimized',element.attr('minimized')=='minimized_0'?'minimized_1':'minimized_0');
    	jQuery.ajax('xmlhttp.php?action=minimize&pos='+element.attr('position')+'&widget='+element.attr('id')+'&minimized='+element.attr('minimized'), {type: 'get'});
    	if(element.attr('minimized')=='minimized_1')
    	{
    		offElement.slideUp(); 
 		    jQuery(button).attr('src','images/hyperportal/collapse_collapsed.gif');

    	}
    	else
    	{
    		offElement.slideDown();
    		jQuery(button).attr('src','images/hyperportal/collapse.gif');
    	}
    }
    
    
    function configurate(pos,widget,serialized)
    {
	    console.log(pos);
	    console.log(widget);
	    console.log(serialized);
	    
	   jQuery.ajax
    				(
	    				'xmlhttp.php?action=makeConfig&pos='+pos+'&widget='+widget+'&config='+serialized,
	    				{
	    					type: 'get',
	    					complete: function(request) 
	    					{ 
	    						var prev=jQuery('#widget_'+widget).prev();
		    					jQuery('#widget_'+widget).hide(0, function() {
									    		jQuery('#widget_'+widget).remove();
									  });
								jQuery(prev).after(request.responseText).fadeIn('fast');
	    					}
	    				}
	    			);
    }
    
    jQuery('document').ready
    (
    	function()
    	{";
    if($mybb->settings["hyperportal_addclose"])
    for($i=1;$i<=$sectors;$i++)
    	$hypercontent.= "
    		jQuery('#sector{$i}Add').click
    		(
    			function()
    			{
    
    			    spinnerImage= 'images/spinner_big.gif';
    				spinner = new ActivityIndicator('body', {image: spinnerImage});
    				jQuery('#sector{$i}Add').hide();
    				jQuery.ajax
    				(
	    				'xmlhttp.php?action=getActiveList&pos=sector{$i}',
	    				{
	    					type: 'get',
	    					complete: function(request) 
	    					{ 

	    						spinner.destroy();
	    						my_dialog=jQuery('<div title=\'".$lang->h_add_widget."\'>'+request.responseText+'</div>').dialog({modal: true});
	    						jQuery('#sector{$i}Add').show();
	    					}
	    				}
	    			);
    			}
    		);";
    
    $hypercontent.= "
    	}
    );

    		
    
    </script>

";



eval("\$hyperportal = \"".$templates->get("hyperportal")."\";");
output_page($hyperportal);
