<?php
/***************************************************************************
*
*  Plugin que genera un portal de widgets customizables
*  Author: BrunoDiaz
*  Copyright: © 2012 BrunoDiaz
*  Este plugin implementa las funciones necesarias para utilizar con el hyperportal
*
***************************************************************************/

/****************************************************************************
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
****************************************************************************/

if(!defined("IN_MYBB"))
die("This file cannot be accessed directly.");

$plugins->add_hook('xmlhttp', 'hyperPortal_xmlhttpOrder');
$plugins->add_hook('xmlhttp', 'hyperPortal_xmlhttpClose');
$plugins->add_hook('xmlhttp', 'hyperPortal_xmlhttpMinimize');
$plugins->add_hook('xmlhttp', 'hyperPortal_xmlhttpGetList');
$plugins->add_hook('xmlhttp', 'hyperPortal_xmlhttpAddWidget');
$plugins->add_hook('xmlhttp', 'hyperPortal_xmlhttpConfigWidget');
$plugins->add_hook('xmlhttp', 'hyperPortal_xmlhttpMakeConfig');

$plugins->add_hook('admin_config_menu', 'hyperPortal_admin_menu');
$plugins->add_hook('admin_config_action_handler', 'hyperPortal_admin_action');

$plugins->add_hook('admin_user_groups_edit_graph', 'hyperPortal_admin_user_groups_edit_graph');
$plugins->add_hook('admin_user_groups_edit_commit', 'hyperPortal_admin_user_groups_edit_commit');

// User CP Options. Thanks GoMobile
$plugins->add_hook("usercp_options_end", "hyperportal_usercp_options");
$plugins->add_hook("usercp_do_options_end", "hyperportal_usercp_options");

//Set Menu Link for forum or portal
$plugins->add_hook("global_end", "hyperportal_global_end");

function hyperPortal_info()
{
	global $lang;
	$lang->load("hyperportal");		
	
	return array(
	"name"			=> "hyperPortal",
	"description"	=> $lang->h_plugin_description,
	"author"		=> "BrunoDiaz",
	"version"		=> "1.0",
	"guid" 		=> "",
	"compatibility"	=> "*"
	);
}


function hyperPortal_install()
{
	global $db,$cache,$lang,$config;
	
	if(!isset($config['admin_dir']))
	{
			$config['admin_dir'] = "admin";
	}
	
	define('MYBB_ADMIN_DIR', MYBB_ROOT.$config['admin_dir'].'/');
	
	$lang->load("hyperportal");		
		
	$defaultTemplate='';
	$db->write_query("ALTER TABLE `".TABLE_PREFIX."usergroups` ADD `hyperportal_template` VARCHAR(500) NOT NULL DEFAULT '$defaultTemplate';");
	$db->write_query("ALTER TABLE `".TABLE_PREFIX."users` ADD `widgets_config` TEXT NOT NULL");

	$db->write_query("CREATE TABLE `".TABLE_PREFIX."widgets` (
`widget_name` VARCHAR( 40 ) NOT NULL,
 `active` tinyint(1) NOT NULL DEFAULT '0',
 `fixed` smallint(6) NOT NULL DEFAULT '0',
 `header` tinyint(1) NOT NULL DEFAULT '1',
 `guests` tinyint(1) NOT NULL DEFAULT '1'
) ENGINE=MyISAM DEFAULT CHARSET=latin1;");

	$cache->update_usergroups();

	//The user can select if he wants to use the forum or the portal
	$db->query("ALTER TABLE ".TABLE_PREFIX."users ADD useportal int(1) NOT NULL default '1'");
	
	$query = $db->query("SELECT disporder FROM ".TABLE_PREFIX."settinggroups ORDER BY `disporder` DESC LIMIT 1");
	$disporder = $db->fetch_field($query, 'disporder')+1;

	$setting_group = array(
	'name' 			=>	'hyperportal_settings',
	'title' 		=>	'HyperPortal',
	'description' 	=>	$lang->h_settings_description,
	'disporder' 	=>	intval($disporder),
	'isdefault' 	=>	'no'
	);
	$db->insert_query('settinggroups', $setting_group);
	$gid = $db->insert_id();

	$settings = array(
	'hyperportal_sectors' 		=> array(
	'title' 			=> $lang->h_settings_sector_title,
	'description' 		=>  $lang->h_settings_sector_description,
	'optionscode'		=> 'text',
	'value'				=> '3'),
	'hyperportal_forum' 		=> array(
	'title' 			=> $lang->h_settings_forum_title,
	'description' 		=> $lang->h_settings_forum_description,
	'optionscode'		=> 'onoff',
	'value'				=> '1'),
	//TODO the add config should be by sector
	'hyperportal_addclose' 		=> array(
	'title' 			=> $lang->h_settings_addclose_title,
	'description' 		=> $lang->h_settings_addclose_description,
	'optionscode'		=> 'onoff',
	'value'				=> '1')

	);

	$x = 1;
	foreach($settings as $name => $setting)
	{
		$insert_settings = array(
		'name' => $db->escape_string($prefix.$name),
		'title' => $db->escape_string($setting['title']),
		'description' => $db->escape_string($setting['description']),
		'optionscode' => $db->escape_string($setting['optionscode']),
		'value' => $db->escape_string($setting['value']),
		'disporder' => $x,
		'gid' => $gid,
		'isdefault' => 0
		);
		$db->insert_query('settings', $insert_settings);
		$x++;
	}

	rebuild_settings();

	//Insert stylesheet
	
    require_once(MYBB_ADMIN_DIR."/inc/functions_themes.php");

    
//Here we define de css default that is used at install
$stylesheet="
.hyperButton
{
	margin-right:1px;
	float:right;
	cursor:pointer;
}
#hypercontent
{
width:100%;
}
.sectorAdd
{   
	background-color: #026AAE;
    background-image: url('images/hyperportal/addWidget.png');
    background-repeat: no-repeat;
    color: white;
    cursor: pointer;
    font-size: 13px;
    font-weight: bold;
    margin-bottom: 2px;
    padding-bottom: 2px;
    padding-left: 40px;
    padding-top: 2px;
}

#sector1Column
{
	float: left;
    padding-right: 15px;
    width: 300px;
}

#sector3Column
{
	clear:both;
}


.widget
{


	margin-bottom:10px;
}
.widgetContent
{
	padding:3px;
}
#sector2Column
{

	padding-left: 312px;

}
.moveHeader
{

	font-family: Verdana,Arial,Sans-Serif;
	font-size:12px;
	line-height:16.8px;
	text-align:left;
	font-weight: bold;
	padding-right:10px;
	padding-left:10px;
	padding-top:10px;
	height: 25px;
}
.dragBorder
{
	border: 1px dashed #061927; 
}
";

    
    // Add stylesheet to the master template so it becomes inherited.
    $myplugin_stylesheet = array(
        'sid' => NULL,
        'name' => 'hyperportal.css',
        'tid' => '1',
        'stylesheet' => $db->escape_string($stylesheet),
        'cachefile' => 'hyperportal.css',
        'attachedto' => 'hyperportal.php',
        'lastmodified' => TIME_NOW,
    );
    $db->insert_query('themestylesheets', $myplugin_stylesheet);
    cache_stylesheet(1, "hyperportal.css", $stylesheet);
    update_theme_stylesheet_list("1");
    
    //Now we create the default template
    require MYBB_ROOT.'/inc/adminfunctions_templates.php';
    $hyperportal_template= array( 
        				"sid"		  => -1,
                        "title"       => "hyperportal",
			     		"template"    => mysql_escape_string('<html>
										<head>
										<title>{$mybb->settings[\'bbname\']}</title>
										{$headerinclude}
										<script type="text/javascript" src="jscripts/fitonpage.js?ver=234"></script>
										
										</head>
										<body>
										{$header}
										
										{$hypercontent}
										
										{$footer}
										</body>
										</html>'));
	 $db->insert_query("templates", $hyperportal_template);	

}

function hyperPortal_uninstall()
{
	global $db,$cache,$config;
	
	if(!isset($config['admin_dir']))
	{
			$config['admin_dir'] = "admin";
	}
	
	define('MYBB_ADMIN_DIR', MYBB_ROOT.$config['admin_dir'].'/');
	
	//Amount of sectors configured
	$sectors=$mybb->settings["hyperportal_sectors"];
	
	//First I need to call uninstall from all the installed widgets
	$widgets_installed=array();
	$widgets_installed_resource = $db->simple_select('widgets', '*');
	while ($widget_installed=$db->fetch_array($widgets_installed_resource))
		$widgets_installed[$widget_installed['widget_name']]=$widget_installed;
		
	for($i=1;$i<=$sectors;$i++)
	{
		$files=get_widget_list("sector$i");
		foreach($files as $codename)
			{
				if(!isset($widgets_installed[$codename]))
					continue;
				require_once MYBB_ROOT."inc/widgets/sector$i/".$codename.".php";;
				
				$uninstallfunc = $codename."_uninstall";
				//Si no tiene un info no es un widget
				if(!function_exists($uninstallfunc))
					continue;
				$uninstallfunc();
			}
	}
	
	$defaultTemplate='';
	$db->write_query("ALTER TABLE `".TABLE_PREFIX."usergroups` DROP COLUMN `hyperportal_template` ");
	$db->write_query("ALTER TABLE `".TABLE_PREFIX."users` DROP COLUMN `widgets_config` ");
	$db->write_query("DROP TABLE `".TABLE_PREFIX."widgets` ");
	$cache->update_usergroups();
	
	$db->query("ALTER TABLE ".TABLE_PREFIX."users DROP COLUMN useportal");
	
	// Remove settings
	$result = $db->simple_select('settinggroups', 'gid', "name = 'hyperportal_settings'", array('limit' => 1));
	$group = $db->fetch_array($result);

	if(!empty($group['gid']))
	{
		$db->delete_query('settinggroups', "gid='{$group['gid']}'");
		$db->delete_query('settings', "gid='{$group['gid']}'");
		rebuild_settings();
	}
	
	//Clean the cache, so if we install again there won't be active widgets
	$cache->update('hyperPortalWidgets', array());

	require_once(MYBB_ADMIN_DIR."inc/functions_themes.php");

	$db->delete_query('themestylesheets', "name='hyperportal.css'");
	
    // Remove hyperportal.css from the theme cache directories if it exists
    $query = $db->simple_select("themes", "tid");
    while($tid = $db->fetch_field($query, "tid"))
    {
        $css_file = MYBB_ROOT."cache/themes/theme{$tid}/hyperportal.css";
        if(file_exists($css_file))
            unlink($css_file);
    }

    update_theme_stylesheet_list("1");

    //Now we delete the template
    require MYBB_ROOT.'/inc/adminfunctions_templates.php';
    $db->query("DELETE FROM ".TABLE_PREFIX."templates WHERE title='hyperportal'");
}

function hyperPortal_is_installed()
{
	global $mybb;
	if(isset($mybb->usergroup['hyperportal_template']))
	return true;
	return false;
}

function hyperPortal_xmlhttpOrder()
{
	global $mybb, $db, $lang ;

	if ($mybb->input['action'] != 'sortWidgets' )
	return;

	$pos=$mybb->input['pos'];

	//Si es un invitado guardo en session en vez de en DB
	if($mybb->usergroup['gid']==1)
	{
		$widgetCookieName = $mybb->settings['cookieprefix'] . 'widgets_config';
		$widgets_config=$_COOKIE[$widgetCookieName];
	}
	else
	$wc=$widgets_config=unserialize($mybb->user[widgets_config]);

	$widgets_config[$pos]=array();
	//TODO revisar que cada widget exista para evitar errores
	foreach($_GET[widget] as $i=>$widget)
	{
		$widgetConfig=array();
		$widgetConfig["name"]=$widget;
		$widgetConfig["minimized"]=$_GET[minimized][$i];
		$widgetConfig["configuration"]=$wc[$pos][$widget]['configuration'];
		
		$widgets_config[$pos][$widget]=$widgetConfig;
	}

	if($mybb->usergroup['gid']!=1)
	{
		// We're saving our options here
		$update_array = array(
		"widgets_config" => mysql_escape_string(serialize($widgets_config))
		);

		$db->update_query("users", $update_array, "uid = '".$mybb->user['uid']."'");
	}
	else
	{
		$widgetCookieName = $mybb->settings['cookieprefix'] . 'widgets_config';
		$_COOKIE[$widgetCookieName]=serialize($widgets_config);
		setcookie($widgetCookieName,$_COOKIE[$widgetCookieName]);
		echo "OK";
	}//TODO echo ERROR SI NO S EPUDO GUARDAR

}


function hyperPortal_xmlhttpMinimize()
{
	global $mybb, $db, $lang ;

	if ($mybb->input['action'] != 'minimize' )
	return;
	$pos=$mybb->input['pos'];

	$widget=substr($mybb->input['widget'],7);
	$minimized=substr($mybb->input['minimized'],10);

	//Si es un invitado guardo en session en vez de en DB
	if($mybb->usergroup['gid']==1)
	{
		$widgetCookieName = $mybb->settings['cookieprefix'] . 'widgets_config';
		$widgets_config=unserialize($_COOKIE[$widgetCookieName]);
		$widgets_config[$pos][$widget]['minimized']=$minimized;

		$_COOKIE[$widgetCookieName]=serialize($widgets_config);
		setcookie($widgetCookieName,$_COOKIE[$widgetCookieName]);
		echo "OK";
		return;
	}

	$widgets_config=unserialize($mybb->user[widgets_config]);
	$widgets_config[$pos][$widget]['minimized']=$minimized;



	// We're saving our options here
	$update_array = array(
	"widgets_config" => mysql_escape_string(serialize($widgets_config))
	);

	$db->update_query("users", $update_array, "uid = '".$mybb->user['uid']."'");


	//TODO echo ERROR SI NO S EPUDO GUARDAR

}

function hyperPortal_xmlhttpClose()
{
	global $mybb, $db, $lang ;

	if ($mybb->input['action'] != 'closeWidget' )
	return;

	$pos=$mybb->input['pos'];

	$widget=substr($mybb->input['widget'],7);

	//Si es un invitado guardo en session en vez de en DB
	if($mybb->usergroup['gid']==1)
	{
		$widgetCookieName = $mybb->settings['cookieprefix'] . 'widgets_config';
		session_start();
		$widgets_config=unserialize($_COOKIE[$widgetCookieName]);
		unset($widgets_config[$pos][$widget]);

		$_COOKIE[$widgetCookieName]=serialize($widgets_config);
		setcookie($widgetCookieName,$_COOKIE[$widgetCookieName]);
		echo "OK";
		return;
	}


	$widgets_config=unserialize($mybb->user[widgets_config]);
	unset($widgets_config[$pos][$widget]);



	// We're saving our options here
	$update_array = array(
	"widgets_config" => mysql_escape_string(serialize($widgets_config))
	);

	$db->update_query("users", $update_array, "uid = '".$mybb->user['uid']."'");


	//TODO echo ERROR SI NO S EPUDO GUARDAR

}


function hyperPortal_xmlhttpConfigWidget()
{
	global $mybb, $db, $lang , $plugins,$config;
	
	if(!isset($config['admin_dir']))
	{
			$config['admin_dir'] = "admin";
	}
	
	define('MYBB_ADMIN_DIR', MYBB_ROOT.$config['admin_dir'].'/');;
	
	if ($mybb->input['action'] != 'configWidget' )
	return;

	$pos=$mybb->input['pos'];

	$codename=substr($mybb->input['widget'],7);

	//TODO I'm using class_form from admindir, but it's the frontend!!
	require_once MYBB_ADMIN_DIR."/inc/class_form.php";
	
	require_once("inc/widgets/$pos/".$codename.".php");

	$configfunc = $codename."_configuration";
	//Si no tiene un info no es un widget
	if(!function_exists($configfunc))
	{
		 echo $lang->h_not_config;
		 return;
	}
	$widgetconfig = $configfunc();
	if(count($widgetconfig)<=0)
	{
		 echo $lang->h_not_config;
		 return;
	}
	
	$form=new DefaultForm('','','configWidget');
	
	$widgets_config=unserialize($mybb->user[widgets_config]);
	$wc=$widgets_config[$pos][$codename];
	foreach($widgetconfig as $name=>$setting)
		{
			$options = "";
			$type = explode("\n", $setting['optionscode']);
			$type[0] = trim($type[0]);
			$element_name = "upsetting[$name]";
			$element_id = "setting_$name";
			
			if(isset($wc['configuration']))
				 $setting['value']=$wc['configuration'][$name];
				 
			if($type[0] == "text" || $type[0] == "")
			{
				$setting_code = $form->generate_text_box($element_name, $setting['value'], array('id' => $element_id));
			}
			else if($type[0] == "textarea")
			{
				$setting_code = $form->generate_text_area($element_name, $setting['value'], array('id' => $element_id));
			}
			else if($type[0] == "yesno")
			{
				$setting_code = $form->generate_yes_no_radio($element_name, $setting['value'], true, array('id' => $element_id.'_yes', 'class' => $element_id), array('id' => $element_id.'_no', 'class' => $element_id));
			}
			else if($type[0] == "onoff")
			{
				$setting_code = $form->generate_on_off_radio($element_name, $setting['value'], true, array('id' => $element_id.'_on', 'class' => $element_id), array('id' => $element_id.'_off', 'class' => $element_id));
			}
			else if($type[0] == "language") 
			{
				$languages = $lang->get_languages();
				$setting_code = $form->generate_select_box($element_name, $languages, $setting['value'], array('id' => $element_id));
			}
			else if($type[0] == "passwordbox")
			{
				$setting_code = $form->generate_password_box($element_name, $setting['value'], array('id' => $element_id));
			}
			else if($type[0] == "php")
			{
				$setting['optionscode'] = substr($setting['optionscode'], 3);
				eval("\$setting_code = \"".$setting['optionscode']."\";");
			}
			else
			{
				for($i=0; $i < count($type); $i++)
				{
					$optionsexp = explode("=", $type[$i]);
					if(!$optionsexp[1])
					{
						continue;
					}
					$title_lang = "setting_{$setting['name']}_{$optionsexp[0]}";
					if($lang->$title_lang)
					{
						$optionsexp[1] = $lang->$title_lang;
					}
					
					if($type[0] == "select")
					{
						$option_list[$optionsexp[0]] = htmlspecialchars_uni($optionsexp[1]);
					}
					else if($type[0] == "radio")
					{
						if($setting['value'] == $optionsexp[0])
						{
							$option_list[$i] = $form->generate_radio_button($element_name, $optionsexp[0], htmlspecialchars_uni($optionsexp[1]), array('id' => $element_id.'_'.$i, "checked" => 1, 'class' => $element_id));
						}
						else
						{
							$option_list[$i] = $form->generate_radio_button($element_name, $optionsexp[0], htmlspecialchars_uni($optionsexp[1]), array('id' => $element_id.'_'.$i, 'class' => $element_id));
						}
					}
					else if($type[0] == "checkbox")
					{
						if($setting['value'] == $optionsexp[0])
						{
							$option_list[$i] = $form->generate_check_box($element_name, $optionsexp[0], htmlspecialchars_uni($optionsexp[1]), array('id' => $element_id.'_'.$i, "checked" => 1, 'class' => $element_id));
						}
						else
						{
							$option_list[$i] = $form->generate_check_box($element_name, $optionsexp[0], htmlspecialchars_uni($optionsexp[1]), array('id' => $element_id.'_'.$i, 'class' => $element_id));
						}
					}
				}
				if($type[0] == "select")
				{
					$setting_code = $form->generate_select_box($element_name, $option_list, $setting['value'], array('id' => $element_id));
				}
				else
				{
					$setting_code = implode("<br />", $option_list);
				}
				$option_list = array();
			}
			// Do we have a custom language variable for this title or description?
			$title_lang = "setting_".$setting['name'];
			$desc_lang = $title_lang."_desc";
			if($lang->$title_lang)
			{
				$setting['title'] = $lang->$title_lang;
			}
			if($lang->$desc_lang)
			{
				$setting['description'] = $lang->$desc_lang;
			}
			
				
			echo "<p id='configWidget'>$setting[title]<br/><small><i>$setting_code</i></small><br/><span class='smalltext'> $setting[description]</span></p>";

		}
		
		$plugins->run_hooks("hyperportal_widgetconfig_graph");
		echo "<style>
			.buttonConfig
			{
				cursor:pointer;
				background-color:gray;
				color:white !important;
				border: 2px solid darkgray;
				padding:3px;
			}
			</style>";
		echo "<a class='buttonConfig' onclick=\"configurate('$pos','$codename',jQuery('form#configWidget').serialize());my_dialog.dialog('close');\" >".$lang->h_config_widget."</a>";
	//TODO echo ERROR SI NO S EPUDO GUARDAR

}


function hyperPortal_xmlhttpGetList()
{
	global $mybb, $db, $lang ;

	$lang->load("hyperportal");

	if ($mybb->input['action'] != 'getActiveList' )
	return;

	$pos=$mybb->input['pos'];

	$widgets=get_ActiveNotUsedWidget($pos);

	if(count($widgets))
	foreach($widgets as $widget)
	{


		echo "<p><a style='cursor:pointer' onClick=\"addWidget('$pos','$widget[name]');my_dialog.dialog('close');\">$widget[title]</a><br/><span class='smalltext'>$widget[description]</span></p>";
	}
	else
	echo "<strong> ".$lang->h_all_widgets_add." </strong>";
	//TODO echo ERROR SI NO S EPUDO GUARDAR

}

function hyperPortal_xmlhttpMakeConfig()
{

	global $mybb,$db,$plugins;
	
	if ($mybb->input['action'] != 'makeConfig')
		return;
	
	$mybb->input['action']='addWidget';
	$mybb->input['dontAdd']='true';

	$ws=$mybb->input['upsetting'];
	
	$pos=$mybb->input['pos'];
	$codename=$mybb->input['widget'];

	$widgets_config=unserialize($mybb->user[widgets_config]);
	$widgets_config[$pos][$codename]['configuration']=$ws;



	// We're saving our options here
	$update_array = array(
		"widgets_config" => mysql_escape_string(serialize($widgets_config))
	);
	
	$plugins->run_hooks("hyperportal_widgetconfig_configure");

	$db->update_query("users", $update_array, "uid = '".$mybb->user['uid']."'");
	
	hyperPortal_xmlhttpAddWidget($ws);
}

function hyperPortal_xmlhttpAddWidget($ws="")
{
	global $mybb, $db, $lang, $cache;

	$lang->load("hyperportal");
	
	global $widget_settings;
	$widget_settings="";
	
	if ($mybb->input['action'] != 'addWidget')
	return;
	
	$codename=$mybb->input['widget'];

	$pos=$mybb->input['pos'];

	$widget_settings=$ws;
	
	$widget=array("name"=>$codename,"minimized"=>0);
	if($mybb->input['dontAdd']!=true)
	{
		//Si es un invitado guardo en session en vez de en DB
		if($mybb->usergroup['gid']==1)
		{
			$widgetCookieName = $mybb->settings['cookieprefix'] . 'widgets_config';
			$widgets_config=unserialize($_COOKIE[$widgetCookieName]);
		}
		else
		$widgets_config=unserialize($mybb->user[widgets_config]);
	
		if(isset($widgets_config[$pos][$codename]))
		return;
	
		$widgets_config[$pos][$codename]=$widget;
	
		//Si es un invitado guardo en session en vez de en DB
		if($mybb->usergroup['gid']==1)
		{
			$widgetCookieName = $mybb->settings['cookieprefix'] . 'widgets_config';
			$_COOKIE[$widgetCookieName]=serialize($widgets_config);
			setcookie($widgetCookieName,$_COOKIE[$widgetCookieName]);
		}
		else
		{
			// We're saving our options here
			$update_array = array(
			"widgets_config" => mysql_escape_string(serialize($widgets_config))
			);
	
			$db->update_query("users", $update_array, "uid = '".$mybb->user['uid']."'");
		}
		
		//I'm not changing settings
		$settedSettings=true;
		
	}
	require_once("inc/widgets/$pos/".$codename.".php");

	$infofunc = $codename."_info";
	//Si no tiene un info no es un widget
	if(!function_exists($infofunc))
	{
		continue;
	}
	$widgetinfo = $infofunc();

	$widgetscache=$cache->read("hyperPortalWidgets",true);

	$conffunc = $codename."_configuration";
	$configButton=false;
	if(function_exists($conffunc))
	{
		$configButton=true;
		if($settedSettings)
		{
			//Using the default settings
			$settings=$conffunc();
			foreach($settings as $name=>$setting)
			{
				$widget_settings[$name]=$setting['value'];
			}
		}

		//If not i use the global widget_settings setted in configure
	}
	
	if($widgetscache[$pos][$codename]['fixed']==1)
	$notClass = "notSortable";


	echo "
<div class='widget trow1 smalltext $notClass' position='$pos' id='widget_$codename' minimized='minimized_0'>";

	if($widgetscache[$pos][$codename]['header']==1)
	echo "<div class=' thead moveHeader' >
						$widgetinfo[name]
			
						<img src='images/hyperportal/close.gif' class='hyperButton' onClick='closeWidget(this)'/>
						<img src='images/hyperportal/collapse$collapsed.gif' class='minimize hyperButton' onClick='minimize(this)'/>";
			if($configButton)
				echo "<img src='images/hyperportal/config.png' class='hyperButton' onClick='configWidget(this)'/>";
			echo	"</div>";

	echo "<div class='widgetContent'>".
	$codename().
	"</div>
		
				</div>";
	//TODO echo ERROR SI NO S EPUDO GUARDAR

}





/**
 * Trae un listado de widgets activos que no estan siendo usados por el usuario
 *
 * @param string $pos posicion de los widgets. Depende de la cantidad de sectores
 * @return devuelve un listado de widgets en la posicion indicada
 */
function get_ActiveNotUsedWidget($pos)
{
	global $mybb,$cache;

	session_start();

	$widgetscache=$cache->read("hyperPortalWidgets",true);

	if($mybb->usergroup['gid']==1)
	{
		$widgetCookieName = $mybb->settings['cookieprefix'] . 'widgets_config';
		$widgets_config=unserialize($_COOKIE[$widgetCookieName]);
	}
	else
	$widgets_config=unserialize($mybb->user[widgets_config]);

	$widgets_config=$widgets_config[$pos];

	$widgetscache=$widgetscache[$pos];

	$return=array();
	if(count($widgetscache)>0)
	foreach ($widgetscache as $widget)
	{

		//Si no es para invitados ni lo cargo
		if($mybb->usergroup['gid']==1 && $widget['guests']==0)
		continue;

		if(!isset($widgets_config[$widget["name"]]))
		$return[]=$widget;
	}

	return $return;
}



/**
 * Trae un listado de widgets
 *
 * @param string $pos posicion de los widgets. 
 * @return devuelve un listado de widgets en la posicion indicada
 */
function get_widget_list($pos)
{
	// Get a list of the plugin files which exist in the plugins directory
	$dir = @opendir(MYBB_ROOT."inc/widgets/$pos");
	if($dir)
	{
		while($file = readdir($dir))
		{
			$ext = get_extension($file);
			if($ext == "php")
			{
				$file=str_replace(".php","",$file);
				$widget_list[] = $file;
			}
		}
		@sort($widget_list);
	}
	@closedir($dir);
	return $widget_list;
}


function hyperPortal_admin_menu(&$menu) {

	global $lang;

	//$lang->load('hyperPortal');

	$menu[] = array('id' => 'hyperPortal', 'title' => "hyper Portal Widgets", 'link' => hyperPortal_admin_url('config', 'hyperportal'));

}

/**
 * Trae la url correspondiente segun la version de mybb
 * Thanks to hyperPortal
 *
 * @param unknown_type $cat
 * @param unknown_type $module
 * @return unknown
 */
function hyperPortal_admin_url($cat, $module) {

	return 'index.php?module='.$cat.($GLOBALS['mybb']->version_code >= 1500 ? '-':'/').$module;

}


function hyperPortal_admin_action(&$actions) {

	$actions['hyperportal'] = array('active' => 'hyperportal', 'file' => 'admin-hyperPortal.php');

}

//Agrego el grafico ordenador de widgets en el panel admin de usergroups
function hyperPortal_admin_user_groups_edit_graph()
{

	global $form,$cache,$mybb;

	echo '<script type="text/javascript" src="http://ajax.googleapis.com/ajax/libs/jquery/1.7.1/jquery.min.js"></script>
			  <script type="text/javascript" src="http://ajax.googleapis.com/ajax/libs/jqueryui/1.8.16/jquery-ui.min.js"></script>
			  <link rel="stylesheet" type="text/css" href="http://ajax.googleapis.com/ajax/libs/jqueryui/1.8.16/themes/base/jquery-ui.css"/>
<script language="javascript" type="text/javascript">jQuery.noConflict();</script>
			  ';

	$widgetscache=$cache->read("hyperPortalWidgets");
	$default=unserialize($mybb->input['hyperportal_template']);

	$sectors=$mybb->settings["hyperportal_sectors"];


echo "<style>
	

	.adminListSector
	{
		width:180px;
		float:left;
		margin-left:10px;
		min-height:50px;
		background-color:#dddddd;
		margin-top:10px;
		border: 1px solid #888888;
	}
	
	</style>";
	
		echo "<center><div >";
		echo "<div style='clear:both'>Default Visible Widgets Order</div>";
		
		
		for($i=1;$i<=$sectors;$i++)
		{
			echo "<div id='sector{$i}Column' class='adminListSector$i adminListSector' >";
			if(count($default["sector$i"]))
				foreach($default["sector$i"] as $widget)
				{
					echo "<div  class='sector{$i}Widget' id='widget_$widget'  style='margin-bottom:3px;min-height:50px;background-color:#dddddd;border:2px solid #888888;'>{$widgetscache["sector$i"][$widget][title]}</div>";	
					unset($widgetscache["sector$i"][$widget]);
		
				}
			echo "</div>";
		}
		echo "<div >";

				echo "		<div style='clear:both'>Default NOT Visible Widgets</div>";
		
		for($i=1;$i<=$sectors;$i++)
		{
				
			echo "<div id='notSector{$i}Column' class='adminListSector$i  adminListSector'  >";
			if(count($widgetscache["sector$i"]))
				foreach($widgetscache["sector$i"] as $widget)
				{
					echo "<div class='notSector{$i}Widget' id='widget_$widget[name]' style='margin-bottom:3px;min-height:50px;background-color:#dddddd;border:2px solid #888888;'>$widget[title]</div>";	
				}
			echo "</div>
			
			<input type='hidden' name='sector{$i}WidgetsOrder' id='sector{$i}WidgetsOrder'/>
			";

		}
		echo "</div>		
		
		

		";
	echo "<div style='clear:both'/>
	<strong>";
	echo $form->generate_check_box('overwrite',false,"Overwrite all");
	echo "</strong> If this ckecbox is activated the configuration for all users will be overwritten. It is only recommended to use if you are installing the portal or if you want to reset it.";

	echo "</div>";

	echo "

<style>
.dragBorder
{
	border: 1px dashed #061927; 
}
</style>
<script>

    jQuery(function() {
";

	for($i=1;$i<=$sectors;$i++)
	{
		echo  "
	  		jQuery( '#sector{$i}Column' ).sortable({
		   			placeholder: 'dragBorder',
		   			connectWith:'#notSector{$i}Column',
		   			forcePlaceholderSize:true,
		   			tolerance: '30%',
		   			update: function( event, ui ) {
		   					var order = jQuery(this).sortable('serialize');
							jQuery('#sector{$i}WidgetsOrder').val(order);
		   			}
		         });
		       
				var order = jQuery('#sector{$i}Column').sortable('serialize');
				
				jQuery('#sector{$i}WidgetsOrder').val(order);
		
				jQuery( '#notSector{$i}Column' ).sortable({
		          	accept: '.sector{$i}Widget',
		            connectWith:'#sector{$i}Column',
		            placeholder: 'dragBorder',
		   			forcePlaceholderSize:true,
		   			tolerance: '30%',
		   			update: function( event, ui ) {
		   					var order = jQuery('#sector{$i}Column').sortable('serialize');
							jQuery('#sector{$i}WidgetsOrder').val(order);
							ui.item.css('margin-left',0);
		   			}
		        });";
	}


	echo "
       
           
    });
</script>
    ";

}


function hyperPortal_admin_user_groups_edit_commit()
{
	global $mybb,$db,$usergroup;
	$sectors=$mybb->settings["hyperportal_sectors"];
	$update=array();
	for($i=1;$i<=$sectors;$i++)
	{
		$sectorW=array();
		$update["sector$i"]=array();
		parse_str($mybb->input["sector$i".'WidgetsOrder'],$sectorW);
		$update["sector$i"]=$sectorW["widget"];
	}



	global $updated_group;

	$updated_group['hyperportal_template']=serialize($update);

	if(isset($mybb->input['overwrite']))
	{
		$widgetConfig=array();

		for($i=1;$i<=$sectors;$i++)
		{
			$widgetConfig["sector$i"]=array();
			if(is_array($update["sector$i"]))
				foreach($update["sector$i"] as $w)
					$widgetConfig["sector$i"][$w]=array("name"=>$w,"minimized"=>0);
		}
		//print_r(unserialize($mybb->user[widgets_config]));
		$db->update_query("users", array("widgets_config"=>serialize($widgetConfig)), "usergroup='{$usergroup['gid']}'");

	}

}


function hyperPortal_usercp_options()
{
	global $db, $mybb, $templates, $user, $lang;

	//See if the user can change the use portal config
	if(!$mybb->settings['hyperportal_forum'])
		return;
		
	$lang->load("hyperportal");

	if($mybb->request_method == "post")
	{
		// We're saving our options here
		$update_array = array(
			"useportal" => intval($mybb->input['useportal'])
		);

		$db->update_query("users", $update_array, "uid = '".$user['uid']."'");
	}

	$usercp_option = '</tr><tr>
<td valign="top" width="1"><input type="checkbox" class="checkbox" name="useportal" id="useportal" value="1" {$GLOBALS[\'$useportalcheck\']} /></td>
<td><span class="smalltext"><label for="useportal">{$lang->h_useportal_desc}</label></span></td>';

	$find = '{$lang->invisible_mode}</label></span></td>';
	$templates->cache['usercp_options'] = str_replace($find, $find.$usercp_option, $templates->cache['usercp_options']);

	// We're just viewing the page
	$GLOBALS['$useportalcheck'] = '';
	if($user['useportal'])
	{
		$GLOBALS['$useportalcheck'] = "checked=\"checked\"";
	}
}

function hyperPortal_global_end()
{
	global $mybb, $lang, $header, $headerinclude;

	$lang->load("hyperportal");

	if(THIS_SCRIPT!="hyperportal.php")
		$headerAdd="<li><a href='{$mybb->settings['bburl']}/hyperportal.php'>{$lang->h_portal}</a></li>";
	else 
		$headerAdd="<li><a href='{$mybb->settings['bburl']}/index.php'>{$lang->h_forum}</a></li>";

	$find = '<div class="menu">';
	$startMenu=strpos($header,$find);
	$startMenu=strpos($header,"<ul>",$startMenu)+4;
	$header = substr($header,1,$startMenu).$headerAdd.substr($header,$startMenu+1);
	
	//We add jquery
	if(THIS_SCRIPT=="hyperportal.php" && strpos(strtolower($headerinclude),"jquery")===FALSE)
		$headerinclude.='<script type="text/javascript" src="http://ajax.googleapis.com/ajax/libs/jquery/1.7.1/jquery.min.js"></script><script type="text/javascript" src="http://ajax.googleapis.com/ajax/libs/jqueryui/1.8.16/jquery-ui.min.js"></script>';
}




?>