<?php

/**
 * MyBB 1.6
 * weather
 *
 * BrunoDiaz
 * UTNianos.com.ar 12/12/12
 */

// Disallow direct access to this file for security reasons
if(!defined("IN_MYBB"))
{
	die("No puede inicializarse de forma externa");
}
function weather_info()
{
	/**
	 * Array of information about the widget.
	 * name: The name of the plugin
	 * description: Description of what the plugin does
	 * website: The website the plugin is maintained at (Optional)
	 * author: The name of the author of the plugin
	 * authorsite: The URL to the website of the author (Optional)
	 * version: The version number of the plugin
	 * guid: Unique ID issued by the MyBB Mods site for version checking
	 * compatibility: A CSV list of MyBB versions supported. Ex, "121,123", "12*". Wildcards supported.
	 */
	
	
	global $lang;
	$lang->load("hyperportal",true);
	
	return array(
		"name"			=> $lang->h_info_weather_title,
		"description"	=> $lang->h_info_weather_description,
		"website"		=> "http://www.utnianos.com.ar",
		"author"		=> "BrunoDiaz",
		"authorsite"	=> "http://www.utnianos.com.ar",
		"version"		=> "1.0",
		"guid" 			=> "",
		"compatibility" => "*",
		// Se puede poner si los usuarios anonimos pueden o no ver el bloque
		// Por default no pueden. Los admin pueden cambiar esto
		"guests"		=> 0
	);
	
	return return_array();
}
	
	function weather()
	{
		
		global $lang,$mybb;
		$lang->load("hyperportal",true);
		
		$ip=$_SERVER['REMOTE_ADDR'];
		
		$weather_string = file_get_contents("http://free.worldweatheronline.com/feed/weather.ashx?q=$ip&format=xml&num_of_days=2&key={$mybb->settings['wweather_key']}"); 
		$weather=simplexml_load_string($weather_string);
		
		if($mybb->settings['wweather_temp']=="F")
		{
			$tempActual="{$weather->current_condition->temp_F}"." °F";
			$tempMananaMax="{$weather->weather[0]->tempMaxF}"." °F";
			$tempMananaMin="{$weather->weather[0]->tempMinF}"." °F";
			$tempPasadoMax="{$weather->weather[1]->tempMaxF}"." °F";
			$tempPasadoMin="{$weather->weather[1]->tempMinF}"." °F";
		}
		else {
			
			$tempActual="{$weather->current_condition->temp_C}"." °C";
			$tempMananaMax="{$weather->weather[0]->tempMaxC}"." °C";
			$tempMananaMin="{$weather->weather[0]->tempMinC}"." °C";
			$tempPasadoMax="{$weather->weather[1]->tempMaxC}"." °C";
			$tempPasadoMin="{$weather->weather[1]->tempMinC}"." °C";
		}
		
		//$weatherRet= "<pre>".print_r($weather,true);
		
		$weatherRet.="
		<center><h2 style='margin:0'>{$lang->h_weather_now}</h2>
				<h2 style='margin:0'>$tempActual</h2>
			<img style='margin:0' src='{$weather->current_condition->weatherIconUrl}'/><br/>
			<b>{$lang->h_weather_humidiy}:</b> {$weather->current_condition->humidity} %
		
	<table style='text-align:center' align='center'>
	<tr>
	<td style='width:50%'>
			<b>{$lang->h_weather_tomorrow}</b><br/>
			<b>{$lang->h_weather_max}:</b>$tempMananaMax<br/>
			<b>{$lang->h_weather_min}:</b>$tempMananaMin
			<img src='{$weather->weather[1]->weatherIconUrl}'/><br/>
	</td>
	<td>
			<b>{$lang->h_weather_dat}</b><br/>
			<b>{$lang->h_weather_max}:</b>$tempPasadoMax<br/>
			<b>{$lang->h_weather_min}:</b>$tempPasadoMin
			<img src='{$weather->weather[1]->weatherIconUrl}'/><br/>
	</td>
	</tr>
	</table>
	
	</center>";
		
		return $weatherRet;
	}

	
	
function weather_install()
{
	global $db,$cache;
	//Create the admin settings
	$query = $db->query("SELECT disporder FROM ".TABLE_PREFIX."settinggroups ORDER BY `disporder` DESC LIMIT 1");
	$disporder = $db->fetch_field($query, 'disporder')+1;

	$setting_group = array(
	'name' 			=>	'wweather_settings',
	'title' 		=>	'Weather Widget',
	'description' 	=>	'Settings to configure your HyperPortal Weather Widget',
	'disporder' 	=>	intval($disporder),
	'isdefault' 	=>	'no'
	);
	$db->insert_query('settinggroups', $setting_group);
	$gid = $db->insert_id();

	$settings = array(
	'wweather_key' 		=> array(
	'title' 			=> 'World Weather Online API Key',
	'description' 		=> 'You need to get an API key from <a href="http://www.worldweatheronline.com/register.aspx">here</a>',
	'optionscode'		=> 'text',
	'value'				=> ''),
	'wweather_temp' 	=> array(
	'title' 			=> 'Temp. Unit',
	'description' 		=> 'Select to show your weather in Celsius or Farenheit',
	'optionscode'		=> 'select
C=Celsius
F=Farenheit',
	'value'				=> 'C')
	);

	$x = 1;
	foreach($settings as $name => $setting)
	{
		$insert_settings = array(
		'name' => $db->escape_string($prefix.$name),
		'title' => $db->escape_string($setting['title']),
		'description' => $db->escape_string($setting['description']),
		'optionscode' => $db->escape_string($setting['optionscode']),
		'value' => $db->escape_string($setting['value']),
		'disporder' => $x,
		'gid' => $gid,
		'isdefault' => 0
		);
		$db->insert_query('settings', $insert_settings);
		$x++;
	}

	rebuild_settings();

}

function weather_uninstall()
{
		global $db,$cache;
	
	// Remove settings
	$result = $db->simple_select('settinggroups', 'gid', "name = 'wweather_settings'", array('limit' => 1));
	$group = $db->fetch_array($result);

	if(!empty($group['gid']))
	{
		$db->delete_query('settinggroups', "gid='{$group['gid']}'");
		$db->delete_query('settings', "gid='{$group['gid']}'");
		rebuild_settings();
	}

}
	

?>