<?php

/**
 * MyBB 1.6
 * Announcements widget
 *
 * BrunoDiaz
 * UTNianos.com.ar 31/1/13e
 */

// Disallow direct access to this file for security reasons
if(!defined("IN_MYBB"))
{
	die("No puede inicializarse de forma externa");
}

function announcements_info()
{
	/**
	 * Array of information about the widget.
	 * name: The name of the plugin
	 * description: Description of what the plugin does
	 * website: The website the plugin is maintained at (Optional)
	 * author: The name of the author of the plugin
	 * authorsite: The URL to the website of the author (Optional)
	 * version: The version number of the plugin
	 * guid: Unique ID issued by the MyBB Mods site for version checking
	 * compatibility: A CSV list of MyBB versions supported. Ex, "121,123", "12*". Wildcards supported.
	 */
	global $lang;
	$lang->load("hyperportal",true);
	
	return array(
		"name"			=> $lang->h_info_announcements_title,
		"description"	=> $lang->h_info_announcements_description,
		"website"		=> "http://www.utnianos.com.ar",
		"author"		=> "BrunoDiaz",
		"authorsite"	=> "http://www.utnianos.com.ar",
		"version"		=> "1.0",
		"guid" 			=> "",
		"compatibility" => "*"
	);
	
	return return_array();
	
	
}


	function announcements_install()
	{
		global $db;
		 //Now we create the default template
    require MYBB_ROOT.'/inc/adminfunctions_templates.php';
    $template= array( 
    					"sid"		  => -1,
                        "title"       => "widget_announcements_announcements",
			     		"template"    => '<tr>

	<td class="{$bgcolor} smalltext">
		{$attachment_count}
		<div>
			<span>{$prefix} {$gotounread}{$thread[threadprefix]}<a href="{$thread_link}{$highlight}" class="{$inline_edit_class} {$new_class}" id="tid_{$inline_edit_tid}">{$thread[subject]}</a>{$thread[multipage]}</span>
			<div class="author smalltext">{$thread[profilelink]}</div>
		</div>
	</td>
</tr>');
	 $db->insert_query("templates", $template);	
	}
	
	function announcements_uninstall()
	{
		global $db;
	    //Now we delete the template
	    require MYBB_ROOT.'/inc/adminfunctions_templates.php';
	    $db->query("DELETE FROM ".TABLE_PREFIX."templates WHERE title='widget_announcements_announcements'");
	}
	
	function announcements()
	{
		global $theme,$plugins,$cache,$db,$mybb,$templates,$widget_settings,$lang;
		
		//We only display global announcements
		$query = $db->simple_select("announcements", "aid, fid, subject, enddate","fid=-1");

		$return="";
		while($announcement = $db->fetch_array($query))
		{
			$global_announcements[$announcement['aid']] = $announcement;
			//If announcement is not expired or it never ends
			if(!($announcement['enddate'] < TIME_NOW && $announcement['enddate'] != 0))
			{
				$announcement['announcementlink']=get_announcement_link($announcement['aid']);
				$return="<div style='width:100%;text-align:center;'><a href='{$announcement['announcementlink']}'{$new_class}>{$announcement['subject']}</a></div>";
			}
		}

		return $return;
	}

?>