<?php

/**
 * MyBB 1.6
 * Widget de prueba
 *
 * BrunoDiaz
 * UTNianos.com.ar 12/12/12
 */

// Disallow direct access to this file for security reasons
if(!defined("IN_MYBB"))
{
	die("No puede inicializarse de forma externa");
}

function twitter_info()
{
	/**
	 * Array of information about the widget.
	 * name: The name of the plugin
	 * description: Description of what the plugin does
	 * website: The website the plugin is maintained at (Optional)
	 * author: The name of the author of the plugin
	 * authorsite: The URL to the website of the author (Optional)
	 * version: The version number of the plugin
	 * guid: Unique ID issued by the MyBB Mods site for version checking
	 * compatibility: A CSV list of MyBB versions supported. Ex, "121,123", "12*". Wildcards supported.
	 */
	global $lang;
	
	$lang->load("hyperportal");
	
	return array(
		"name"			=> $lang->h_info_twitter_title,
		"description"	=> $lang->h_info_twitter_description,
		"website"		=> "http://www.utnianos.com.ar",
		"author"		=> "BrunoDiaz",
		"authorsite"	=> "http://www.utnianos.com.ar",
		"version"		=> "1.0",
		"guid" 			=> "",
		"compatibility" => "*"
	);
	
	return return_array();
}
	
function twitter_install()
{
	global $db,$cache;
	//Create the admin settings
	$query = $db->query("SELECT disporder FROM ".TABLE_PREFIX."settinggroups ORDER BY `disporder` DESC LIMIT 1");
	$disporder = $db->fetch_field($query, 'disporder')+1;

	$setting_group = array(
	'name' 			=>	'wtwitter_settings',
	'title' 		=>	'Twitter Widget',
	'description' 	=>	'Settings to configure your HyperPortal Twitter Widget',
	'disporder' 	=>	intval($disporder),
	'isdefault' 	=>	'no'
	);
	$db->insert_query('settinggroups', $setting_group);
	$gid = $db->insert_id();

	$settings = array(
	'wtwitter_profile' 		=> array(
	'title' 			=> 'Twitter profile',
	'description' 		=> 'Profile used in the widget',
	'optionscode'		=> 'text',
	'value'				=> ''),
	'wtwitter_list' 		=> array(
	'title' 			=> 'Twitter List',
	'description' 		=> 'Used only in List mode',
	'optionscode'		=> 'text',
	'value'				=> ''),
	'wtwitter_title' 	=> array(
	'title' 			=> 'Title',
	'description' 		=> 'Description of the twitter',
	'optionscode'		=> 'text',
	'value'				=> 'Twitter Widget'),
	'wtwitter_mode' 		=> array(
	'title' 			=> 'Twitter mode',
	'description' 		=> 'Select if you will show an user\'s tweets or a list\'s tweets',
	'optionscode'		=> 'select
profile=User
list=List',
	'value'				=> 'profile')
	);

	$x = 1;
	foreach($settings as $name => $setting)
	{
		$insert_settings = array(
		'name' => $db->escape_string($prefix.$name),
		'title' => $db->escape_string($setting['title']),
		'description' => $db->escape_string($setting['description']),
		'optionscode' => $db->escape_string($setting['optionscode']),
		'value' => $db->escape_string($setting['value']),
		'disporder' => $x,
		'gid' => $gid,
		'isdefault' => 0
		);
		$db->insert_query('settings', $insert_settings);
		$x++;
	}

	rebuild_settings();

}

function twitter_uninstall()
{
		global $db,$cache;
	
	// Remove settings
	$result = $db->simple_select('settinggroups', 'gid', "name = 'wtwitter_settings'", array('limit' => 1));
	$group = $db->fetch_array($result);

	if(!empty($group['gid']))
	{
		$db->delete_query('settinggroups', "gid='{$group['gid']}'");
		$db->delete_query('settings', "gid='{$group['gid']}'");
		rebuild_settings();
	}

}

	function twitter()
	{

		global $mybb;
		
		$twitter="
		
		<div id='twitter'></div>
<script>

jQuery.getScript('http://widgets.twimg.com/j/2/widget.js', function(data, textStatus, jqxhr) {


new TWTR.Widget({
  version: 2,
  type: '{$mybb->settings['wtwitter_mode']}',
  rpp: 5,
  interval: 6000,
  width: 'auto',
  id:'twitter',
  height: 150,
   title: '{$mybb->settings['wtwitter_title']}',
  theme: {
    shell: {

      background: '#8ec1da',
      color: '#ffffff'
    },
    tweets: {
      background: '#ffffff',
      color: '#444444',
      links: '#1985b5'
    }
  },
  features: {
    scrollbar: false,
    loop: true,
    live: true,
    hashtags: true,
    timestamp: true,
    avatars: true,
    toptweets: true,
    behavior: 'default'
  }
  
}).render()";

if($mybb->settings['wtwitter_mode']=="list")
	$twitter.=".setList('{$mybb->settings['wtwitter_profile']}','{$mybb->settings['wtwitter_list']}').start();";
else 
	$twitter.=".setUser('{$mybb->settings['wtwitter_profile']}').start();";
	$twitter.="twitterCreated=1;
});

</script>";

	return $twitter;
	}

?>